assume cs:codesg

codesg segment
start:       
getstr:                          ;ַӳ
    push ax
    
getstrs:
    mov ah, 0
    int 16h
    cmp al, 20h
    jb nochar                    ;ASCIIС20h˵ַ
    mov ah, 0
    call charstack               ;ַջ
    mov ah, 2
    call charstack               ;ʾջеַ
    jmp getstrs
    
nochar:
    cmp ah, 0eh                  ;˸ɨ
    je backspace
    cmp ah, 1ch                  ;Enterɨ
    je enter1
    jmp getstrs
    
backspace:
    mov ah, 1
    call charstack               ;ַջ
    mov ah, 2
    call charstack               ;ʾջеַ
    jmp getstrs
    
enter1:
    mov al, 0
    mov ah, 0
    call charstack               ;0ջ
    mov ah, 2
    call charstack               ;ʾջеַ
    pop ax
    ret
	
charstack: jmp short charstart    ; ַջջջʾ
table  dw charpush, charpop, charshow
top    dw 0

charstart:
    push bx
    push dx
    push di
    push es
    
    cmp ah, 2
    ja sret
    mov bl, ah
    mov bh, 0
    add bx, bx
    jmp word ptr table[bx]
    
charpush:
    mov bx, top
    mov [si][bx], al
    inc top
    jmp sret
    
charpop:
    cmp top, 0
    je sret
    dec top
    mov bx, top
    mov al, [si][bx]
    jmp sret
    
charshow:
    mov bx, 0b800h
    mov es, bx
    mov al, 160
    mov ah, 0
    mul dh
    mov di, ax
    add dl, dl
    mov ah, 0
    add di, dx
    
    mov bx, 0
    
charshows:
    cmp bx, top
    jne noempty
    mov byte ptr es:[di], ' '
    jmp sret
    
noempty:
    mov al, [si][bx]
    mov es:[di], al
    mov byte ptr es:[di+2], ' '
    inc bx
    add di, 2
    jmp charshows
    
sret:
    pop es
    pop di
    pop dx
    pop bx
    ret
    
codesg ends

end start